<template>
    <div class="visual-filter">
      <div class="filter-value">
        <div>Type:</div>
        <div>({{nodeInfos.type}})</div>
        <input type="range" min="0" max="1" value="selectedWaveForm" @change="handleTypeChange" />
      </div>   
      <div class="filter-value">
        <div>Frequency: </div>
        <input type="range" min="0" max="4000" v-model="nodeInfos.frequency.value" />
      </div>
    </div>
</template>

<script type="ts">
    import { defineComponent } from 'vue'

    const filterTypes = ['lowpass', 'highpass'];

    export default defineComponent({
        name: "VisualFilter",
        props: {
          nodeInfos: BiquadFilterNode
        },
        data() {
          return {
            selectedType: filterTypes.indexOf(this.nodeInfos.type)
          };
        },
        methods: {
          handleTypeChange(e) {
            this.selectedType = filterTypes[e.target.value];
            this.nodeInfos.type = this.selectedType
          }
        }
    })
</script>

<style>
.visual-filter {
  display: flex;
  flex-direction: column;
}

.filter-value {
  display: flex;
  gap: 4px;
}
</style>
